#include <stdlib.h>
#include <stdio.h>
#include <math.h>

int
main(int argc, char *argv[])
{
  extern void init_fft(), mmod();
  extern unsigned int isquare();
  unsigned int ls, lb, s;
  int i, j, p, *n;

  ls = atoi(argv[1]);
  lb = atoi(argv[2]);
  p = atoi(argv[3]);
  init_fft(ls,lb);
  s = 1<<ls;

  n = (int *)(calloc(s,sizeof(int)));
  n[0] = 4;
  for ( i = 1 ; i < s ; i++ ) n[i] = 0;

  for ( i = 0 ; i < p-2 ; i++ )
  {
    if ( j = isquare(n) ) { printf("fft error. (%d)\n",j); return(0); }
    mmod(n,p);
    mmod(n,p);
    n[0] -= 2;
  }

  for ( j = 7 ; j >= 0 ; j-- ) printf("%d ",n[j]);
  printf("\n");

  return(0);
}
